<template>
    <div class="carti-wizard-container full-width">
        <div class="full-width">
            <div class="carti-wizard-header">
                <ul>
                    <li class="finished">
                        <span><img src="/images/step-check.svg"></span>
                        1. Install App
                    </li>
                    <li class="finished">
                        <span><img src="/images/step-check.svg"></span>
                        2. Approve Plan
                    </li>
                    <li class="active">
                        <span>3</span>
                        3. Activate Cart Recovery
                    </li>
                </ul>
            </div>
            <div class="carti-wizard-body">
                <div class="progress-title text-center">
                    Your progress:
                    <span>
                        Step 3/3 - Activate cart recovery
                    </span>
                </div>
                <div
                    class="progress-bar"
                    :class="progress === 100 ? 'completed' : ''"
                >
                    <div
                        class="progress"
                        :style="{width: progress + '%'}"
                    >
                        {{ progress }}% Complete
                    </div>
                </div>
                <div class="title text-center">
                    What are you getting?
                </div>
                <div class="row list-row">
                    <div class="col-md-3 mb-4">
                        <div class="list-box">
                            <div class="list-title text-center">
                                Email Cart Recovery
                            </div>
                            <div class="subtitle">
                                <span>Features</span>
                            </div>
                            <i
                                slot="extra"
                                class="mdi mdi-check"
                            />
                            <div class="checkboxes">
                                <PrettyCheck
                                    v-model="emailRemindersStatus"
                                    class="p-svg"
                                >
                                    <svg
                                        style="width:17px;height:17px"
                                        viewBox="0 0 24 24"
                                        class="svg svg-icon"
                                    >
                                        <path
                                            fill="#4786FF"
                                            d="M9,20.42L2.79,14.21L5.62,11.38L9,14.77L18.88,4.88L21.71,7.71L9,20.42Z"
                                        />
                                    </svg>
                                    5 Email Reminders
                                </PrettyCheck>
                                <PrettyCheck
                                    v-model="emailViewedProductsStatus"
                                    class="p-svg"
                                >
                                    <svg
                                        style="width:17px;height:17px"
                                        viewBox="0 0 24 24"
                                        class="svg svg-icon"
                                    >
                                        <path
                                            fill="#4786FF"
                                            d="M9,20.42L2.79,14.21L5.62,11.38L9,14.77L18.88,4.88L21.71,7.71L9,20.42Z"
                                        />
                                    </svg>
                                    3 Browse abandonment reminders
                                </PrettyCheck>
                            </div>
                            <div class="subtitle">
                                <span>Info</span>
                            </div>
                            <ul>
                                <li>5 Email reminders</li>
                                <li>Optimized sending times</li>
                                <li>Optimized subject lines for enhanced open rates</li>
                                <li>Mobile optimized and conversion proofed templates</li>
                                <li>Discount dripping for optimized conversion</li>
                            </ul>
                        </div>
                    </div>
                    <div class="col-md-3 mb-4">
                        <div class="list-box">
                            <div class="list-title text-center">
                                SMS Cart Recovery
                            </div>
                            <div class="subtitle">
                                <span>Features</span>
                            </div>
                            <div class="checkboxes">
                                <PrettyCheck
                                    v-model="smsRemindersStatus"
                                    class="p-svg"
                                >
                                    <svg
                                        style="width:17px;height:17px"
                                        viewBox="0 0 24 24"
                                        class="svg svg-icon"
                                    >
                                        <path
                                            fill="#4786FF"
                                            d="M9,20.42L2.79,14.21L5.62,11.38L9,14.77L18.88,4.88L21.71,7.71L9,20.42Z"
                                        />
                                    </svg>
                                    3 SMS Reminders
                                </PrettyCheck>
                            </div>
                            <div class="subtitle">
                                <span>Info</span>
                            </div>
                            <ul>
                                <li>Optimized sending times</li>
                                <li>Conversion optimized SMS content</li>
                                <li>Persnolized SMS messages per customer</li>
                                <li>Discount dripping for optimized conversion</li>
                            </ul>
                        </div>
                    </div>
                    <div class="col-md-3 mb-4">
                        <div class="list-box">
                            <div class="list-title text-center">
                                Push Cart Recovery
                            </div>
                            <div class="subtitle">
                                <span>Features</span>
                            </div>
                            <div class="checkboxes">
                                <PrettyCheck
                                    v-model="pushRemindersStatus"
                                    class="p-svg"
                                >
                                    <svg
                                        style="width:17px;height:17px"
                                        viewBox="0 0 24 24"
                                        class="svg svg-icon"
                                    >
                                        <path
                                            fill="#4786FF"
                                            d="M9,20.42L2.79,14.21L5.62,11.38L9,14.77L18.88,4.88L21.71,7.71L9,20.42Z"
                                        />
                                    </svg>
                                    5 Push Reminders
                                </PrettyCheck>
                            </div>
                            <div class="subtitle">
                                <span>Info</span>
                            </div>
                            <ul>
                                <li>Optimized sending times</li>
                                <li>Mobile optimized and conversion proofed templates</li>
                                <li>Discount dripping for optimized conversion</li>
                            </ul>
                        </div>
                    </div>
                    <div class="col-md-3 mb-4">
                        <div class="list-box">
                            <div class="list-title text-center">
                                Growth Tool
                            </div>
                            <div class="subtitle">
                                <span>Features</span>
                            </div>
                            <div class="checkboxes">
                                <PrettyCheck
                                    v-model="growthToolsStatus"
                                    class="p-svg"
                                >
                                    <svg
                                        style="width:17px;height:17px"
                                        viewBox="0 0 24 24"
                                        class="svg svg-icon"
                                    >
                                        <path
                                            fill="#4786FF"
                                            d="M9,20.42L2.79,14.21L5.62,11.38L9,14.77L18.88,4.88L21.71,7.71L9,20.42Z"
                                        />
                                    </svg>
                                    <span>Optimized growth tool to</span>
                                    <span style="display: block">capture new subscribers</span>
                                </PrettyCheck>
                            </div>
                            <div class="subtitle">
                                <span>Info</span>
                            </div>
                            <ul>
                                <li>Exit intent popup</li>
                                <li>Collect email subscribes</li>
                                <li>Collect push subscribers</li>
                                <li>Collect SMS subscribers</li>
                                <li>Offer a discount in exchange for subscribing</li>
                            </ul>
                        </div>
                    </div>
                </div>
                <div class="row discount-box">
                    <div class="col-md-6">
                        <div class="title">
                            Set Up Max Discount
                        </div>
                        <div>
                            Let us know what is the biggest % discount you’re willing to offer customers in order to
                            recover their orders and we’ll take care of the rest!
                        </div>
                    </div>
                    <div class="col-md-6">
                        <div class="discount-form-container">
                            <div class="title">
                                Max Discount
                            </div>
                            <div class="discount-form">
                                <div>
                                    <div class="input-container" style="width: 70px;">
                                        <InputNumber v-model="discount"  title="Max Discount"/>
                                        <span>%</span>
                                    </div>
                                </div>
                                <div class="text-center full-width">
                                    <b-btn
                                        :class="[{'loading-xs': loading}, {'loading-btn': loading}]"
                                        type="button"
                                        :disabled="loading"
                                        class="blue-btn full-width mb-1"
                                        @click="publish"
                                    >
                                        Publish
                                    </b-btn>
                                    <br>
                                    <a
                                        class="link-grey"
                                        @click="skipped"
                                    >
                                        I'll do it later
                                    </a>
                                </div>
                            </div>
                        </div>
                    </div>
                </div>
            </div>
        </div>
    </div>
</template>

<script>
import PrettyCheck from 'pretty-checkbox-vue/check'
import headers from '@/helpers/authHeader'
import plan from '@/mixins/pricing/pricing.service'
import shop from '@/mixins/shop.service'
import link from '@/helpers/backLink'
import InputNumber from '@/components/elements/InputNumber'

export default {
    name: "Setup4",
    components: { PrettyCheck, InputNumber},
    mixins: [headers, plan, shop, link],
    data() {
        return {
            plan: '',
            discount: 30,
            progress: 66,
            loading: false,
            emailRemindersStatus: true,
            emailViewedProductsStatus: true,
            smsRemindersStatus: true,
            pushRemindersStatus: true,
            growthToolsStatus: true,
        }
    },
    methods: {

        skipped() {
            this.segmentSkipped().then(res => {
                this.$router.push('/dashboard')
            })
        },
        publish() {
            this.loading = true
            axios.post(this.getSegment() + '/setup/finished', {
                discount: this.discount,
                update_discount_values: true,
                statuses: {
                    email_reminders_status: this.emailRemindersStatus,
                    email_viewed_products_status: this.emailViewedProductsStatus,
                    sms_reminders_status: this.smsRemindersStatus,
                    push_reminders_status: this.pushRemindersStatus,
                    growth_tools_status: this.growthToolsStatus
                }
            }, this.getUserHeader()).then(response => {
                this.animateValue(this.progress, 100, 700)
            }).catch((error) => {
                console.log(error)
            }).finally(() => {
                this.loading = false;
            });
        },
        animateValue(start, end, duration) {
            if (start === end) return;
            let range = end - start;
            let current = start;
            let increment = end > start ? 1 : -1;
            let stepTime = Math.abs(Math.floor(duration / range));

            let timer = setInterval(function () {
                current += increment;
                this.progress = current;
                if (current === end) {
                    clearInterval(timer);
                    this.$router.push('/dashboard?installed=1')
                }
            }.bind(this), stepTime);
        },
    }
}
</script>

<style lang="scss">
@import '~pretty-checkbox/src/scss/variables';
@import '~pretty-checkbox/src/scss/core';
@import '~pretty-checkbox/src/scss/states/indeterminate';
@import "resources/css/colors";

.loading-btn {
    width: 100%;
    padding: 10px 20px;
    font-weight: bold;
    border-radius: 5px;
    font-size: 14px;
    border-color: #c1c1c1 !important;
    color: #c1c1c1 !important;
    background: #c1c1c1;

    &:hover {
        background: #c1c1c1 !important;
        border-color: #c1c1c1 !important;
        color:  #c1c1c1 !important;
        text-decoration: none;
    }
}

.carti-wizard-container {
    display: flex;
    align-items: center;
    min-height: 100vh;
    max-width: 1180px;
    margin: 0 auto;


    .pretty {
        display: block;
        margin-top: 15px;

        .svg-icon {
            top: -1px !important;
        }

        .state label:before {
            top: 0 !important;
            border: 2px solid #4786ff;
        }

        .state label:after {
            top: 0 !important;
        }

    }

    .carti-wizard-body {
        background: #ffffff;
        padding: 20px 30px;
        @media (max-width: 770px) {
            padding: 15px;
        }

        .progress-title {
            font-size: 18px;
            font-weight: 500;
            margin-bottom: 10px;

            span {
                color: #4786FF;
            }
        }

        .progress-bar {
            float: none;
            background: #DAE7FF;
            border-radius: 20px;
            width: 100%;
            max-width: 780px;
            height: 24px;
            margin: 0 auto 20px auto;

            &.completed {
                background: #3FC61E;

                .progress {
                    background: #3FC61E;
                }
            }

            .progress {
                background: #3FC61E;
                border-radius: 20px;
                height: 24px;
                color: #ffffff;
                display: block;
                text-align: center;
                font-size: 14px;
                font-weight: 500;
                line-height: 24px;
            }
        }

        .title {
            font-size: 18px;
            font-weight: 500;
            margin-bottom: 20px;
        }

        @media (min-width: 770px) {
            .list-row {
                display: flex;
            }
        }

        .list-box {
            border: 1px solid #DEE1E6;
            border-radius: 5px;
            padding: 15px 20px;
            color: #03183B;
            height: 100%;

            &.disabled {
                position: relative;

                &:before {
                    position: absolute;
                    left: 0;
                    top: 0;
                    content: '';
                    width: 100%;
                    height: 100%;
                    z-index: 1;
                }

                .disabled-container {
                    opacity: 0.25;
                }

                .connect-btn-container {
                    position: absolute;
                    top: 50%;
                    margin-top: -20px;
                    z-index: 2;
                    text-align: center;
                    width: 100%;
                    margin-left: -20px;
                }

                .btn {
                    padding-left: 15px;
                    padding-right: 15px;
                }
            }

            .list-title {
                margin-bottom: 15px;
                font-weight: 500;
            }

            .subtitle {
                position: relative;
                font-weight: 500;
                color: #98A0A6;
                margin-bottom: 10px;

                &:before {
                    position: absolute;
                    left: -20px;
                    top: 10px;
                    content: '';
                    width: calc(100% + 40px);
                    height: 1px;
                    background: #DEE1E6;
                }

                span {
                    position: relative;
                    background: #ffffff;
                    padding: 0 5px;
                    margin-left: -5px;
                }
            }

            ul {
                margin: 0;
                padding: 0;

                li {
                    position: relative;
                    list-style: none;
                    margin-bottom: 10px;
                    padding-left: 24px;

                    &:before {
                        position: absolute;
                        left: 5px;
                        top: 8px;
                        content: '';
                        background: #4786FF;
                        width: 6px;
                        height: 6px;
                        border-radius: 50%;
                    }

                    &:last-child {
                        margin-bottom: 0;
                    }
                }
            }
        }

        .discount-box {
            .title {
                font-size: 16px;
                margin-bottom: 10px;
            }

            .discount-form-container {
                max-width: 240px;
                margin-left: auto;
            }

            .discount-form {
                display: flex;
                justify-content: space-between;

                .input-container {
                    display: flex;
                    align-items: center;
                    border: 1px solid #DAE7FF;
                    border-radius: 5px;
                    padding: 9px 14px 9px 6px;
                    margin-right: 10px;
                    /* Chrome, Safari, Edge, Opera */
                    input::-webkit-outer-spin-button,
                    input::-webkit-inner-spin-button {
                        -webkit-appearance: none;
                        margin: 0;
                    }

                    /* Firefox */
                    input[type=number] {
                        -moz-appearance: textfield;
                    }

                    input {
                        border: 0;
                        text-align: center;
                        color: #4786FF;
                        -moz-appearance: textfield;
                        -webkit-appearance: none;
                        margin: 0;
                        min-width: 33px;

                        &:hover,
                        &:focus {
                            border: 0;
                            outline: none;
                        }
                    }

                    span {
                        margin-left: 5px;
                        color: #98A0A6;
                    }

                    &.has-error {
                        border-color: red;
                    }
                }
            }
        }

        .link-grey {
            cursor: pointer;
            color: #98A0A6;
            text-decoration: none;

            &:hover {
                color: #4786FF;
            }
        }

        .checkboxes {
            margin-bottom: 10px;
        }
    }
}

.carti-wizard-header {
    background: #FCFCFC;
    padding: 20px;

    ul {
        display: flex;
        justify-content: space-around;
        margin: 0 auto;
        padding: 0;
        max-width: 850px;

        li {
            position: relative;
            list-style: none;
            font-size: 16px;
            font-weight: 500;
            padding-top: 50px;

            span {
                position: absolute;
                top: 0;
                left: 50%;
                margin-left: -20px;
                width: 40px;
                height: 40px;
                border-radius: 50%;
                text-align: center;
                font-weight: 500;
                line-height: 38px;
                border: 2px solid #3FC61E;
                color: #3FC61E;
            }

            &.finished {
                color: #98A0A6;

                span {
                    background: #3FC61E;
                }
            }

            &.active {
                color: #4786FF;

                span {
                    color: #4786FF;
                    border-color: #DAE7FF;
                }
            }
        }
    }
}

.carti-wizard-container .carti-wizard-body {
    padding: 20px 30px 120px;
}
</style>
